<?php
class RemovedIdAndReplacedPrimaryKeyWithTweetId extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = 'removed_id_and_replaced_primary_key_with_tweet_id';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'drop_field' => array(
				'ev_twitter_twitter_feeds' => array('id', 'indexes' => array('PRIMARY')),
			),
			'alter_field' => array(
				'ev_twitter_twitter_feeds' => array(
					'tweet_id' => array('type' => 'string', 'null' => false, 'length' => 100, 'key' => 'primary', 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
				),
			),
			'create_field' => array(
				'ev_twitter_twitter_feeds' => array(
					'indexes' => array(
						'PRIMARY' => array('column' => 'tweet_id', 'unique' => 1),
					),
				),
			),
		),
		'down' => array(
			'create_field' => array(
				'ev_twitter_twitter_feeds' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'indexes' => array(
						'PRIMARY' => array(),
					),
				),
			),
			'alter_field' => array(
				'ev_twitter_twitter_feeds' => array(
					'tweet_id' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 100, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
				),
			),
			'drop_field' => array(
				'ev_twitter_twitter_feeds' => array('indexes' => array('PRIMARY')),
			),
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return boolean Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return boolean Should process continue
 */
	public function after($direction) {
		return true;
	}
}
